using UnityEngine;
using System.Collections;
using System;

public class objsound : MonoBehaviour {
	int objno = 0; // change this for multiple RTcmix instantiations
    rtcmixmain RTcmix;
    private bool did_start = false;

    GameObject observer;

    public TextAsset score1;
	string objscore;

	Bounds inbox;

	flamesound1 flamp1;
	flamesound2 flamp2;
	flamesound3 flamp3;
	flamesound4 flamp4;

    private void Awake()
    {
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();

        observer = GameObject.Find("observer");

        flamp1 = GameObject.Find("flame1").GetComponent<flamesound1>();
        flamp2 = GameObject.Find("flame2").GetComponent<flamesound2>();
        flamp3 = GameObject.Find("flame3").GetComponent<flamesound3>();
        flamp4 = GameObject.Find("flame4").GetComponent<flamesound4>();
    }


    // Use this for initialization
    void Start () {
		objscore = score1.text;
		
		RTcmix.initRTcmix (objno);

		RTcmix.SendScore ("MAXBANG(0.1)", objno);

		inbox = new Bounds (new Vector3(0, 2, 0), new Vector3(8, 4, 4));

        did_start = true;
	}
	
	// Update is called once per frame
	void Update () {
        if (!did_start) return;

		// distance
		Transform observertransform = observer.transform;
		Vector3 actualcenter = new Vector3 (transform.position.x,
			transform.position.y + 2.0f,
			transform.position.z);
		float distance = Vector3.Distance (observertransform.position, actualcenter);
		float freqmult = (1.0f - distance / 20.0f) * 5000.0f;
		if (freqmult < 500.0f)
			freqmult = 500.0f;

        // this opens the filter when we get closer
		RTcmix.setpfieldRTcmix (1, freqmult, objno);

        // this turns on the reverb if we're inside the thing
		float rvbamp = 0.0f;
		if (inbox.Contains (new Vector3 (observertransform.position.x,
			    observertransform.position.y,
			    observertransform.position.z))) {
			rvbamp = (1.0f - distance / 4.0f);  // the divisor scales how fast the rvb comes on inside the box
			if (rvbamp > 1.0f)
				rvbamp = 1.0f;
			if (rvbamp < 0.0f)
				rvbamp = 0.0f;
		}

        // this turns down the flame sounds when we're inside the thing
		flamp1.flameamp = 1.0f - (rvbamp * 3.0f); // will scale this  to 1.0 in flamesound
		flamp2.flameamp = 1.0f - (rvbamp * 3.0f); // will scale this  to 1.0 in flamesound
		flamp3.flameamp = 1.0f - (rvbamp * 3.0f); // will scale this  to 1.0 in flamesound
		flamp4.flameamp = 1.0f - (rvbamp * 3.0f); // will scale this  to 1.0 in flamesound

		RTcmix.setpfieldRTcmix (2, rvbamp, objno);
	}

	// this function is called by unity for every buffer of sound samples computed
	void OnAudioFilterRead(float[] data, int channels) {
        if (!did_start) return;

		RTcmix.runRTcmix (data, objno, 0);

		if (RTcmix.checkbangRTcmix (objno) == 1) {
			RTcmix.SendScore (objscore, objno);
		}
	}

    void OnApplicationQuit()
    {
        RTcmix = null;
        did_start = false;
    }
}
